uniform highp float TIME;

uniform mediump float SIZE;

uniform lowp sampler2D TEXTURE0;

varying lowp vec3 Normal;
varying lowp vec3 ViewDirAndDist;
varying mediump vec2 DeferredTexCoord;

void main()
{
	const mediump float A = 60.0;
	const mediump float B = 40.0;
	const mediump float C = 50.0;
	const mediump float D = 30.0;
	const mediump float T1 = 2.0;
	const mediump float T2 = 3.0;
	const mediump float T3 = 2.5;
	const mediump float T4 = 3.5;
	const mediump float S = 0.005;
	
	mediump vec2 offset;
	offset.x = sin(DeferredTexCoord.x * A + cos(TIME * T1)) * cos(DeferredTexCoord.y * B + sin(TIME * T2));
	offset.y = cos(DeferredTexCoord.x * C + sin(TIME * T3)) * sin(DeferredTexCoord.y * D + cos(TIME * T4));
	
	/*dobrze bo SIZE to jest taki factor 1.0 to normalna wielkosc, a 0.0 to wygaszony */	
	mediump float edge = max(dot(normalize(ViewDirAndDist), Normal), 0.0);
	mediump vec2 DeferredTexCoord2 = DeferredTexCoord + offset * edge * edge * SIZE * S;
			
	lowp vec3 transparency = texture2D(TEXTURE0, DeferredTexCoord2).rgb;	
		
	gl_FragColor = vec4(transparency, 1.0);
}
