uniform lowp sampler2D TEXTURE0;

varying mediump vec2 TexCoord;

uniform mediump float RED;
uniform mediump float GREEN;
uniform mediump float BLUE;
uniform mediump float SATURATION;
uniform mediump float LIGHTNESS;
uniform mediump float BIAS;

void main()
{
	lowp vec3 color = texture2D(TEXTURE0, TexCoord.xy).rgb;
	
	lowp float luminance = color.r * 0.30 + color.g * 0.59 + color.b * 0.11;
	
	color *= vec3(RED, GREEN, BLUE);

	color = color * SATURATION + vec3(luminance) * (1.0 - SATURATION);

	color = color * (LIGHTNESS - BIAS) + vec3(BIAS);
	
	gl_FragColor = vec4(color, 1.0);
}
