uniform lowp sampler2D TEXTURE0;
uniform lowp sampler2D TEXTURE1;
uniform lowp float FADE;
uniform lowp vec4 COLOR;

varying lowp vec4 Color;
varying mediump vec2 TexCoord;

uniform highp float TIME;

uniform lowp float START_DISAPPEAR_DISTANCE_FROM;
uniform lowp float END_DISAPPEAR_DISTANCE_FROM;

uniform lowp float START_DISAPPEAR_DISTANCE_TO;
uniform lowp float END_DISAPPEAR_DISTANCE_TO;


varying mediump float DistanceEnd;
varying mediump float DistanceStart;

void main()
{

	lowp vec4 texColour = texture2D(TEXTURE0, vec2(TexCoord.x, TexCoord.y - TIME)) * (1.0 - FADE)
						+ texture2D(TEXTURE1, vec2(TexCoord.x, TexCoord.y - TIME)) * FADE;
	
	lowp float alpha_end = min((DistanceEnd - END_DISAPPEAR_DISTANCE_FROM) / (END_DISAPPEAR_DISTANCE_TO - END_DISAPPEAR_DISTANCE_FROM), 1.0);
	texColour.a *= alpha_end;

	lowp float alpha_start = min((DistanceStart - START_DISAPPEAR_DISTANCE_FROM) / (START_DISAPPEAR_DISTANCE_TO - START_DISAPPEAR_DISTANCE_FROM), 1.0);
	texColour.a *= alpha_start;

	gl_FragColor = texColour;
}
