uniform mediump mat3 EVIRONMENT_TEXTURE_MATRIX;

uniform mediump float PARALAX_STRENGHT;

uniform lowp vec4 MATERIAL_DIFFUSE;
uniform lowp vec3 MATERIAL_ENVIRONMENT;

/* Normal map and bump map */
uniform lowp sampler2D TEXTURE1;

/* enviroment map */
uniform lowp samplerCube TEXTURE2;

varying lowp vec3 Normal;
varying lowp vec3 Tangent;
varying lowp vec3 Bitangent;
varying mediump vec2 TexCoord;
varying mediump vec3 ViewDirAndDist;

void main()
{
	mediump vec3 ViewDir = normalize(ViewDirAndDist);
	
	mediump vec2 offset;
	offset.x = dot(ViewDir, Tangent);
	offset.y = dot(ViewDir, Bitangent);
	mediump vec2 TexCoordParalaxed = TexCoord + offset * ((texture2D(TEXTURE1, TexCoord).a * 2.0 - 1.0) * PARALAX_STRENGHT);
		
	lowp vec3 normalMap = texture2D(TEXTURE1, TexCoordParalaxed).rgb * 2.0 - 1.0;
	
	lowp vec3 normal = normalMap.x * Tangent + normalMap.y * Bitangent + normalMap.z * Normal;
	
	mediump vec3 envDir = -reflect(ViewDir, normal); /* minus bo viewDir to eye-vertex, a reflect to ViewDir - 2*dot(ViewDir, normal) * normal */
	mediump vec3 envTexCoord = EVIRONMENT_TEXTURE_MATRIX * envDir;	
	lowp vec3 enviroment = MATERIAL_ENVIRONMENT * textureCube(TEXTURE2, envTexCoord).rgb;	

	gl_FragColor = vec4(enviroment, MATERIAL_DIFFUSE.a);
}
