uniform lowp sampler2D TEXTURE0;
uniform lowp sampler2D TEXTURE1;

varying mediump vec2 TexCoord;
varying mediump vec2 GlowTexCoord;

uniform mediump float GLOW_QUADRATICSTRENGTH;
uniform mediump float GLOW_LINEARSTRENGTH;
uniform lowp float GLOW_TRESHOLD;

void main()
{
	lowp vec3 color1 = texture2D(TEXTURE0, TexCoord).rgb;
	lowp vec3 color2 = texture2D(TEXTURE1, GlowTexCoord).rgb;

	color2 = max(color2 - GLOW_TRESHOLD, 0.0) * (1.0 / (1.0 - GLOW_TRESHOLD));
	
	gl_FragColor = vec4(color1 + (color2 * color2 * GLOW_QUADRATICSTRENGTH + color2 * GLOW_LINEARSTRENGTH), 1.0);
}
