uniform mediump vec2 CIRCLE_POS;
uniform mediump float RADIOUS_FROM;
uniform mediump float RADIOUS_TO;
uniform mediump vec2 ARC_CENTER_DIRECTION;
uniform mediump float ANGLE_COS;
uniform highp float PIXEL_SIZE;

uniform lowp sampler2D TEXTURE0;
uniform lowp vec4 COLOR;

varying mediump vec2 TexCoord;

varying highp vec2 VirtualScreenPos;

void main()
{	
	lowp float alpha = 0.0;

	highp vec2 pos = VirtualScreenPos - CIRCLE_POS;
	highp float r = length(pos);
	
	highp vec2 posI = normalize(pos);
	
	mediump float t = dot(posI, ARC_CENTER_DIRECTION);
		
	/*Probowalem zapisac ten if inaczej, ale nie da sie rzutowac nijak bool na float...*/
	/*if (r >= RADIOUS_FROM && r <= RADIOUS_TO &&	t >= ANGLE_COS)
	{
		alpha = 1.0;
	}*/
	
	highp float invPixelSize = 1.0 / PIXEL_SIZE;
	mediump float a1 = clamp((r - RADIOUS_FROM) * invPixelSize, -0.5, 0.5);
	mediump float a2 = clamp((RADIOUS_TO - r) * invPixelSize, -0.5, 0.5);
	mediump float a3 = clamp((t - ANGLE_COS) * 180.0 / 3.14159 , -0.5, 0.5);
	alpha = (a1 + 0.5) * (a2 + 0.5) * (a3 + 0.5);
	
	gl_FragColor = texture2D(TEXTURE0, TexCoord) * COLOR * vec4(1.0, 1.0, 1.0, alpha);
}
