uniform lowp sampler2D TEXTURE0;
uniform lowp vec4 COLOR;

uniform mediump float DISAPPEAR_DISTANCE_FROM;
uniform mediump float DISAPPEAR_DISTANCE_TO;

varying mediump vec2 TexCoord;

varying mediump float Distance;

void main()
{
	lowp float alpha = min((Distance - DISAPPEAR_DISTANCE_FROM) / (DISAPPEAR_DISTANCE_TO - DISAPPEAR_DISTANCE_FROM), 1.0);

	lowp vec4 color = texture2D(TEXTURE0, TexCoord) * COLOR;
	color.a *= alpha;
	
	gl_FragColor = color;
}
