uniform mediump float SHININESS;

uniform lowp vec3 LIGHTANDMATERIAL_AMBIENT;

uniform lowp vec4 MATERIAL_DIFFUSE;

uniform lowp vec3 LIGHT0_LIGHTDIR;
uniform lowp vec3 LIGHT0_LIGHTCOLOR;

uniform lowp sampler2D TEXTURE0;

varying lowp vec3 Normal;
varying mediump vec2 TexCoord;

void main()
{
	lowp vec4 materialColor = texture2D(TEXTURE0, TexCoord);
	
	lowp vec3 diffuseLight = LIGHT0_LIGHTCOLOR * max(dot(Normal, LIGHT0_LIGHTDIR), 0.0);

	gl_FragColor = vec4(materialColor.rgb * (diffuseLight * MATERIAL_DIFFUSE.rgb + LIGHTANDMATERIAL_AMBIENT),			
						MATERIAL_DIFFUSE.a);
}
