uniform mediump float SHININESS;

uniform lowp vec3 LIGHTANDMATERIAL_AMBIENT;

uniform lowp vec4 MATERIAL_DIFFUSE;

uniform lowp vec3 LIGHT0_LIGHTDIR;
uniform lowp vec3 LIGHT0_LIGHTCOLOR;
uniform lowp vec3 LIGHT1_LIGHTCOLOR;
uniform mediump float LIGHT1_ATTENUATION;

uniform lowp sampler2D TEXTURE0;

varying mediump vec3 Light1DirAndDist;
varying lowp vec3 Normal;
varying mediump vec2 TexCoord;

void main()
{
	lowp vec4 materialColor = texture2D(TEXTURE0, TexCoord);
	
	lowp vec3 Light1Dir = normalize(Light1DirAndDist);
	lowp float att = 1.0 / (1.0 + LIGHT1_ATTENUATION * dot(Light1DirAndDist, Light1DirAndDist));	
	
	lowp vec3 diffuseLight = LIGHT0_LIGHTCOLOR * max(dot(Normal, LIGHT0_LIGHTDIR), 0.0) +
							 LIGHT1_LIGHTCOLOR * max(dot(Normal, Light1Dir), 0.0) * att;

	gl_FragColor = vec4(materialColor.rgb * (diffuseLight * MATERIAL_DIFFUSE.rgb + LIGHTANDMATERIAL_AMBIENT),			
						MATERIAL_DIFFUSE.a);
}
