uniform mediump mat3 EVIRONMENT_TEXTURE_MATRIX;

uniform lowp vec3 MATERIAL_ENVIRONMENT;

/* Normal map and bump map */
uniform lowp sampler2D TEXTURE1;

/* enviroment map */
uniform lowp samplerCube TEXTURE2;

varying lowp vec3 Normal;
varying lowp vec3 Tangent;
varying lowp vec3 Bitangent;
varying mediump vec2 TexCoord;
varying mediump vec3 ViewDirAndDist;

void main()
{	
	lowp vec3 normalMap = texture2D(TEXTURE1, TexCoord).rgb;
	normalMap.xy = normalMap.xy * 2.0 - 1.0;
	lowp vec3 normal = normalMap.x * Tangent + normalMap.y * Bitangent + normalMap.z * Normal;
	
	mediump vec3 envDir = -(normalize(ViewDirAndDist) + normal);
	mediump vec3 envTexCoord = EVIRONMENT_TEXTURE_MATRIX * envDir;	
	lowp vec3 enviroment = textureCube(TEXTURE2, envTexCoord).rgb;	
	
	gl_FragColor = vec4(enviroment * MATERIAL_ENVIRONMENT, 1.0);				
}
