uniform mediump mat3 EVIRONMENT_TEXTURE_MATRIX;

uniform lowp vec3 MATERIAL_ENVIRONMENT;

/* Normal map and bump map */
uniform lowp sampler2D TEXTURE1;

/* enviroment map */
uniform lowp samplerCube TEXTURE2;

varying lowp vec3 Normal;
varying lowp vec3 Tangent;
varying lowp vec3 Bitangent;
varying mediump vec2 TexCoord;
varying mediump vec3 ViewDirAndDist;

void main()
{	
	mediump vec3 ViewDir = normalize(ViewDirAndDist);

	lowp vec3 normalMap = texture2D(TEXTURE1, TexCoord).rgb;
	normalMap.xy = normalMap.xy * 2.0 - 1.0;
	lowp vec3 normal = normalMap.x * Tangent + normalMap.y * Bitangent + normalMap.z * Normal;
	
	mediump vec3 envDir1 = -(ViewDir + normal);
	mediump vec3 envDir2 = -ViewDir;
	mediump vec3 envTexCoord1 = EVIRONMENT_TEXTURE_MATRIX * envDir1;	
	mediump vec3 envTexCoord2 = EVIRONMENT_TEXTURE_MATRIX * envDir2;	
	lowp vec3 enviroment = textureCube(TEXTURE2, envTexCoord1).rgb
						 + textureCube(TEXTURE2, envTexCoord2).rgb;
	
	gl_FragColor = vec4(enviroment * MATERIAL_ENVIRONMENT * 0.5, 1.0);				
}
