uniform mediump float SHININESS;
uniform mediump float FRESNEL;

uniform lowp vec3 LIGHTANDMATERIAL_AMBIENT;

uniform lowp vec4 MATERIAL_DIFFUSE;
uniform lowp vec3 MATERIAL_SPECULAR;

uniform lowp vec3 LIGHT0_LIGHTDIR;
uniform lowp vec3 LIGHT0_LIGHTCOLOR;

/* Diffuse and alpha/specular */
uniform lowp sampler2D TEXTURE0;

varying lowp vec3 Normal;
varying mediump vec2 TexCoord;
varying lowp vec3 Light0_HalfDir;

void main()
{
	lowp vec4 materialDiffuseAndSpec = texture2D(TEXTURE0, TexCoord);
	
	lowp vec3 diffuseLight = LIGHT0_LIGHTCOLOR * max(dot(Normal, LIGHT0_LIGHTDIR), 0.0);
	lowp vec3 specularLight = LIGHT0_LIGHTCOLOR * pow(max(dot(Normal, Light0_HalfDir), 0.0), SHININESS);

	mediump float fres = 1.0 - clamp(Normal.z, 0.0, 1.0); /* musi byc clamp bo nie do konca znormalizowane te wektory sa */
	mediump float fres2 = fres * fres; /* szybciej tak niz potega */
	mediump float fresnel = 1.0 + FRESNEL * fres2 * fres2 * fres;
	specularLight *= fresnel;
	
	gl_FragColor = vec4(materialDiffuseAndSpec.rgb * (diffuseLight * MATERIAL_DIFFUSE.rgb + LIGHTANDMATERIAL_AMBIENT) +				
						materialDiffuseAndSpec.a * specularLight * MATERIAL_SPECULAR,
						MATERIAL_DIFFUSE.a);
}
