uniform lowp sampler2D TEXTURE0;
uniform lowp float FADE;
uniform lowp vec4 COLOR;

varying lowp vec4 Color;
varying mediump vec2 TexCoord;

uniform highp float START_DISAPPEAR_DISTANCE_FROM;
uniform highp float END_DISAPPEAR_DISTANCE_FROM;

uniform highp float START_DISAPPEAR_DISTANCE_TO;
uniform highp float END_DISAPPEAR_DISTANCE_TO;


void main()
{


	highp vec4 texColour = texture2D(TEXTURE0, TexCoord); 


	highp float alpha_end = min(( END_DISAPPEAR_DISTANCE_FROM - gl_FragCoord.y) / (END_DISAPPEAR_DISTANCE_TO - END_DISAPPEAR_DISTANCE_FROM), 1.0);
	texColour.a *= alpha_end; 


	highp float alpha_start = min(( gl_FragCoord.y - START_DISAPPEAR_DISTANCE_FROM) / (START_DISAPPEAR_DISTANCE_TO - START_DISAPPEAR_DISTANCE_FROM), 1.0);
	texColour.a *= alpha_start;


	gl_FragColor = texColour * COLOR;
}
