uniform lowp sampler2D TEXTURE0;
uniform lowp vec4 COLOR;

varying mediump vec2 TexCoord;


uniform highp float START_DISAPPEAR_DISTANCE_FROM;
uniform highp float END_DISAPPEAR_DISTANCE_FROM;

uniform highp float START_DISAPPEAR_DISTANCE_TO;
uniform highp float END_DISAPPEAR_DISTANCE_TO;


void main()
{
	lowp vec4 color = texture2D(TEXTURE0, TexCoord.xy);

	
	highp float alpha_end = min(( END_DISAPPEAR_DISTANCE_FROM - gl_FragCoord.y) / (END_DISAPPEAR_DISTANCE_TO - END_DISAPPEAR_DISTANCE_FROM), 1.0);
	color.a *= alpha_end; 


	highp float alpha_start = min(( gl_FragCoord.y - START_DISAPPEAR_DISTANCE_FROM) / (START_DISAPPEAR_DISTANCE_TO - START_DISAPPEAR_DISTANCE_FROM), 1.0);
	color.a *= alpha_start;


	gl_FragColor = vec4(COLOR.rgb, color.a * COLOR.a);
}
