uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform mediump float SIZE;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;
attribute mediump vec2 inTexCoord;

varying lowp vec3 Normal;
varying lowp vec3 ViewDirAndDist;
varying mediump vec2 DeferredTexCoord;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);
					 
	highp vec4 pos = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex.x, inVertex.y, inVertex.z * SIZE, 1.0));
	gl_Position = pos;
	highp float iw = 1.0 / pos.w;
	DeferredTexCoord = (pos.xy * iw * 0.5) + vec2(0.5, 0.5);

	Normal = normalize(NormalMatrix * inNormal);
	
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex, 1.0)).xyz;
	ViewDirAndDist = -vertex;	
}
