uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform mediump float STEP_H;
uniform mediump float STEP_V;

attribute mediump vec3 inVertex;
attribute mediump vec2 inTexCoord;

varying mediump vec2 TexCoord0;
varying mediump vec2 TexCoord1;
varying mediump vec2 TexCoord2;
varying mediump vec2 TexCoord3;
varying mediump vec2 TexCoord4;

void main(void)
{
	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	
	TexCoord0 = inTexCoord;
	TexCoord1 = vec2(inTexCoord.x - 0.5 * STEP_H, inTexCoord.y + 1.5 * STEP_V);
	TexCoord2 = vec2(inTexCoord.x + 0.5 * STEP_H, inTexCoord.y - 1.5 * STEP_V);
	TexCoord3 = vec2(inTexCoord.x - 1.5 * STEP_H, inTexCoord.y - 0.5 * STEP_V);
	TexCoord4 = vec2(inTexCoord.x + 1.5 * STEP_H, inTexCoord.y + 0.5 * STEP_V);
}