uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform mediump float STEP_V;

attribute mediump vec3 inVertex;
attribute mediump vec2 inTexCoord;

varying mediump vec2 TexCoord0;
varying mediump vec2 TexCoord1;
varying mediump vec2 TexCoord1n;
varying mediump vec2 TexCoord2;
varying mediump vec2 TexCoord2n;
varying mediump vec2 TexCoord3;
varying mediump vec2 TexCoord3n;
varying mediump vec2 TexCoord4;
varying mediump vec2 TexCoord4n;

void main(void)
{
	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	TexCoord0 = inTexCoord;
	TexCoord1  = vec2(inTexCoord.x, inTexCoord.y + 1.5 * STEP_V);
	TexCoord1n = vec2(inTexCoord.x, inTexCoord.y - 1.5 * STEP_V);
	TexCoord2  = vec2(inTexCoord.x, inTexCoord.y + 3.5 * STEP_V);
	TexCoord2n = vec2(inTexCoord.x, inTexCoord.y - 3.5 * STEP_V);
	TexCoord3  = vec2(inTexCoord.x, inTexCoord.y + 5.5 * STEP_V);
	TexCoord3n = vec2(inTexCoord.x, inTexCoord.y - 5.5 * STEP_V);
	TexCoord4  = vec2(inTexCoord.x, inTexCoord.y + 7.5 * STEP_V);
	TexCoord4n = vec2(inTexCoord.x, inTexCoord.y - 7.5 * STEP_V);	
}