uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform mediump float SIZE;
uniform mediump vec3 END_POSITION;
uniform mediump vec3 START_POSITION;

attribute highp vec3 inVertex;
attribute mediump vec2 inTexCoord;
attribute lowp vec4 inColor;

varying lowp vec4 Color;
varying mediump vec2 TexCoord;

varying mediump float DistanceEnd;
varying mediump float DistanceStart;


void main(void)
{
	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex.x, inVertex.y, inVertex.z * SIZE, 1.0));
	
	DistanceEnd  = length(inVertex - END_POSITION );
	DistanceStart = length(inVertex - START_POSITION );

	TexCoord = inTexCoord;
}
