uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform lowp vec3 LIGHT0_LIGHTDIR;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;
attribute mediump vec2 inTexCoord;
attribute mediump vec2 inTexCoord2;

varying lowp vec3 Normal;
varying mediump vec2 TexCoord;
varying mediump vec2 TexCoord2;
varying lowp vec3 Light0_HalfDir;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);
	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	TexCoord = inTexCoord;	
	TexCoord2 = inTexCoord2;	
	Normal = normalize(NormalMatrix * inNormal);
	
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex, 1.0)).xyz;
	mediump vec3 viewDir = normalize(-vertex);
	Light0_HalfDir = normalize(viewDir + LIGHT0_LIGHTDIR);	
}
