uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;
attribute lowp vec3 inTangent;
attribute lowp float inBitangentSign;
attribute mediump vec2 inTexCoord;

/* ViewDir mediump bo inaczej artefakty na paralax mapie duze */
varying lowp vec3 Normal;
varying lowp vec3 Tangent;
varying lowp vec3 Bitangent;
varying mediump vec2 TexCoord;
varying mediump vec3 ViewDirAndDist;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);
	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	TexCoord = inTexCoord;	
	Normal = normalize(NormalMatrix * inNormal);
	Tangent = normalize(NormalMatrix * inTangent);
	Bitangent = cross(Tangent, Normal) * inBitangentSign; /* Tutaj BEZ NormalMatrix JUZ bo juz sa w dobrej przestrzeni */
	
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex, 1.0)).xyz;
	ViewDirAndDist = -vertex;	
}
