uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;

varying mediump vec2 TexCoordEnv;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);

	const mediump float A = 2.0; /* wspolczynnik zalamania. Predkosc w osrodku 1 do osrodka 2 */

	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex, 1.0)).xyz;	
	mediump vec3 viewDir = normalize(-vertex);
	lowp vec3 normal = NormalMatrix * inNormal;
	
	
	/*Wzor uproszony :) Ale to vertex shader to mozna zaszalec z lepszym
	TexCoordEnv = (viewDir - normal);*/
	
	mediump float angle = acos(dot(-viewDir, normal));
	mediump vec3 k = cross(normal, viewDir);
	mediump vec3 y = cross(k, normal);
	mediump float sb = sin(angle) / A;
	mediump float beta = asin(sb);
		
	mediump vec3 tex = -(y * sb - normal * cos(beta));
	TexCoordEnv = normalize(tex).xy * 0.5 + vec2(0.5, 0.5);
}
