uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

attribute highp vec3 inVertex;

/* ViewDir mediump bo inaczej artefakty na paralax mapie duze */
varying lowp vec3 Normal;
varying mediump vec3 ViewDirAndDist;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);

	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	Normal = normalize(NormalMatrix * inVertex);
	
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex, 1.0)).xyz;
	ViewDirAndDist = -vertex;	
}
