uniform highp mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform lowp vec3 LIGHT0_LIGHTDIR;

uniform mediump float SHADOW_MAX_DISTANCE;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;

void main()
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);

	lowp vec3 normal = NormalMatrix * inNormal;
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex - inNormal * 0.001, 1.0)).xyz; /*inNormal by z-fighting wyeliminowac*/

	/* Tu musi byc if. Nie da sie clamp, bo jak cos moze miec pechowy ksztalt to skaszani sie */
	if (dot(normal, LIGHT0_LIGHTDIR) < 0.0) vertex -= LIGHT0_LIGHTDIR * SHADOW_MAX_DISTANCE;
	
	gl_Position = PROJECTIONMATRIX * vec4(vertex, 1.0);
}