uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform lowp vec3 LIGHT0_LIGHTDIR;
uniform mediump vec3 LIGHT1_LIGHTPOS;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;
attribute mediump vec2 inTexCoord;

varying mediump vec3 Light1DirAndDist;
varying lowp vec3 Normal;
varying mediump vec2 TexCoord;
varying lowp vec3 Light0_HalfDir;
varying lowp vec3 Light1_HalfDir;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);
	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	TexCoord = inTexCoord;	
	Normal = normalize(NormalMatrix * inNormal);
		
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex, 1.0)).xyz;
	mediump vec3 viewDir = normalize(-vertex);
	Light0_HalfDir = normalize(viewDir + LIGHT0_LIGHTDIR);
	
	Light1DirAndDist = LIGHT1_LIGHTPOS - vertex;	
	Light1_HalfDir = normalize(viewDir + normalize(Light1DirAndDist));	
	
}
