uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform mediump vec3 LIGHT1_LIGHTPOS;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;
attribute mediump vec2 inTexCoord;

varying mediump vec3 Light1DirAndDist;
varying lowp vec3 Normal;
varying mediump vec2 TexCoord;
varying lowp vec3 ReflectViewDir;
varying mediump float Distance;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);

	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	TexCoord = inTexCoord;	
	Normal = normalize(NormalMatrix * inNormal);
	
	mediump vec3 vertex = (MODELVIEWMATRIX * vec4(inVertex, 1.0)).xyz;
	Distance = -vertex.z;
	mediump vec3 viewDir = normalize(-vertex);
	Light1DirAndDist = LIGHT1_LIGHTPOS - vertex;	
	
	ReflectViewDir = -reflect(viewDir, Normal);
}
