uniform mediump mat4 PROJECTIONMATRIX;
uniform mediump mat4 MODELVIEWMATRIX;

uniform lowp vec3 LIGHT0_LIGHTDIR;
uniform lowp vec3 LIGHT0_LIGHTCOLOR;

uniform lowp vec4 MATERIAL_DIFFUSE;

uniform lowp vec3 LIGHTANDMATERIAL_AMBIENT;

attribute highp vec3 inVertex;
attribute lowp vec3 inNormal;
attribute mediump vec2 inTexCoord;

varying lowp vec4 Color;
varying mediump vec2 TexCoord;

void main(void)
{
	mediump mat3 NormalMatrix = mat3(MODELVIEWMATRIX[0].xyz, MODELVIEWMATRIX[1].xyz, MODELVIEWMATRIX[2].xyz);

	gl_Position = PROJECTIONMATRIX * (MODELVIEWMATRIX * vec4(inVertex, 1.0));
	TexCoord = inTexCoord;
	
	mediump vec3 normal = NormalMatrix * inNormal;

	Color = vec4(LIGHT0_LIGHTCOLOR * MATERIAL_DIFFUSE.rgb * max(dot(normal, LIGHT0_LIGHTDIR), 0.0) + LIGHTANDMATERIAL_AMBIENT, MATERIAL_DIFFUSE.a);
}
